+++

title = "Appliquer facilement un filtre HADOPI et journaliser ses entrées"
date = 2010-09-27
aliases = [ "post/2010/09/27/Appliquer-facilement-un-filtre-HADOPI-et-le-journaliser-les-entrées"]
[taxonomies]
tags = [ "hadopi", "pare-feux" ]
+++

Juste pour le fun…

<!-- more -->

Si tu maîtrises à 100% ton routeur (ou si tu maîtrises à 100% ton pare-feu personnel), tu peux toi aussi te prémunir très facilement des soucis que tu pourrais rencontrer sur Internet.

Pour cela, c'est très simple, on commence par se rendre sur [le site du RIPE](http://www.ripe.net/db/whois-free.html) (c'est l'organisme qui distribue les adresses IP sur Internet pour la partie européenne). Une fois que tu auras tapé le mot-clé « HADOPI » dans le champs recherche, tu pourras admirer les plages d'adresses IP qui ont été attribuées à la Haute Autorité. Oui, parce qu'il faut savoir que la HADOPI ne peut pas utiliser des adresses chez M. Orange ou M. SFR pour espionner les rézo de P2P. Sinon, elle pourrait se faire dénoncer elle-même, ce qui provoquerait une rupture du continuum espace-temps qui pourrait déchirer le tissu même de l'univers… Ou elle pourrait s'envoyer une lettre recommandé et se suspendre l'accès Internet.

Bien sûr, il ne faut pas non plus oublier les quelques adresses indispensables de [TMG](http://fr.wikipedia.org/wiki/Trident_Media_Guard), le bras armé de la HADOPI. La page Wikipédia nous renseigne également sur les IP publiques utilisées par les serveurs chargés de faire la détection sur les rézo P2P, des contrefacteurs honteux, de ces criminels en puissance qui menacent de lapider nos artistes que nous aimons tant à coup de bits (sans mauvais jeu de mots… enfin, si en fait ^^).

# Ainsi font, font, font les petits paquets IP

On va donc se servir de cette mine de renseignement ainsi que de la [calculatrice IP de HobbesWorld|http://www.hobbesworld.com/reseaux/calcip.php|fr], que je me permet de remercier au passage, pour mettre en place quelques règles dans ton pare-feu/routeur préféré. Le but ici est exclusivement de respecter les lois et directives européennes et notamment 2002/58/CE et 95/46/CE relative à la protection de la vie privée et des données personnelles.

Donc, prenons par exemple, cette plage pour la HADOPI :
![HADOPI, plage 3, sept. 2010](/.hadopi_ip_test_m.jpg)

Notre petite calculatrice IP nous indique cette plage correspond au masque 28, ce que l'on peut vérifier très facilement avec la commande `sipcalc` :
```
$ sipcalc 90.80.100.192/28 | grep range
Network range	\	- 90.80.100.192 - 90.80.100.207
Usable range	\	- 90.80.100.193 - 90.80.100.206
```

Allez, je suis bon prince, je t'épargne les calculs, voici l'ensemble des adresses pouvant être utilisées par la HADOPI ou la société TMG, avec leur masque et tout le tralala :
* 85.159.236.252/30
* 85.159.232.80/30
* 82.138.81.211
* 193.107.240.0/22
* 193.105.197.0/24
* 90.80.155.240/28
* 90.80.155.208/28
* 90.80.100.192/28
* 80.12.48.0/24
* 195.6.180.141

Voilà, voilà, voilà *\*sifflote\**

Reste maintenant à éditer quelques règles au niveau du pare-feu pour empêcher les empêcheurs de tourner en rond de nuire à tes télécha^W^Wta vie privée.

#  « HADOPI, ça marche ! »

J'utilise un routeur/pare-feu Linux, je donnerai donc seulement les règles `iptables` qui vont bien, je te charge d'adapter à ta situation/ton matériel. Donc, une règle toute conne comme celle qui suit devrait faire l'affaire :
```
iptables -I FORWARD -p all -s 85.159.236.252/30,85.159.232.80/30,\
82.138.81.211/32,193.107.240.0/22,193.105.197.0/24\
90.80.155.240/28,90.80.155.208/28,90.80.100.192/28\
80.12.48.0/24,195.6.180.141/32 -j DROP
```

Bon évidemment, il vaut mieux la mettre avant d'autres règles (des fois que tu ais d'autres choses à bloquer…). Maintenant, il ne reste plus qu'à vérifier que cela fonctionne…

# Hé, ho, on est pas cousins !

Pour cela, je te propose deux méthodes, une compliquée, une simple :
* pinguer l'adresse 193.105.197.1 : si elle répond, c'est pas bon. Si elle ne répond pas, c'est bon.
* télécharger un film sur un réseau P2P quelconque et attendre la lettre recommandée.

Plus sérieusement, on peut très simplement logguer les paquets avec une petite bafouille de ce type, avant la règle donnée au point précédent :
```
iptables -I FORWARD -p all -s 85.159.236.252/30,85.159.232.80/30,\
82.138.81.211/32,193.107.240.0/22,193.105.197.0/24\
90.80.155.240/28,90.80.155.208/28,90.80.100.192/28\
80.12.48.0/24,195.6.180.141/32 -j LOG --log-prefix 'HADOPI'
```

Si nos petits camarades responsables de certains trackers célèbres peuvent appliquer le même filtre, ce serait encore mieux. Et au passage, je vous déconseille fortement de vous connecter avec un client eMule sur les adresse en 85.x.x.x citées dans le présent billet.
