+++
title = "Réparer ou jeter, que faire ?"
date = 2022-10-27
[taxonomies]
tags = [ "bricole-picole" ]
+++

> Bah moi, mon frigo, il a 40 ans et il tourne toujours.

Papy Mougeot

<!-- more -->

Je te livre ici une réflexion qui remonte à très très très loin. Ça fait un moment que je me pose la question et avec le contexte de crise climatique actuel, je pense que cette réflexion mûrit à point (en tout cas, j’espère).

Je précise tout de suite que je ne suis pas en train de te dicter ton comportement. Ni en train de te dire que je vais sauver la planète (on en est même loin). J’essaie simplement de donner un contexte et quelques données qui permettront (peut-être) de prendre une décision assez simple : faut-il racheter (et donc jeter) ou réparer ?

# *if it ain’t broken, don’t fix it*

Tout d’abord, le premier critère et certainement le plus important pour le moment : **s’il fonctionne et qu’il remplit correctement sa fonction, il n’y a aucune raison de remplacer un appareil**.

Voilà, c’est dit, c’est simple. Si ça marche, absolument aucune raison de changer un appareil. Ça a l’air con comme ça, mais ça fait déjà une grosse différence : ta télé marche ? Oui, alors tu la changes pas. Ton ordinateur marche ? Oui, donc aucune raison de le changer.

Je mettrais tout de même une petite exception à cela : si l’appareil est polluant ou particulièrement inefficace énergétiquement à l’utilisation. Je donnerai un exemple plus bas, mais c’est aussi pour illustrer le fait que rien n’est absolu dans ce que je dis. Il faut y réfléchir pratiquement au cas par cas.

# La capacité de diagnostic

À partir du moment où un appareil est en panne, ou ne remplit plus complètement ses fonctions, la première chose est d’arriver à établir un diagnostic : qu’est-ce qui ne marche pas ? Et surtout, pourquoi, ça ne marche pas ?

Là, déjà, on a largué une bonne partie du commun des mortels. Et je ne parle même pas de questions d’électronique ou d’informatique, le simple fait d’avoir ton lave-linge qui ne vidange plus, c’est déjà presque trop pour la plupart des gens.

Ne négligeons pas cet aspect : même les informaticiens les plus chevronnés ne sont pas toujours capables de diagnostiquer correctement un souci purement électronique. Rien n’est simple et rien n’est évident.

L’espoir que j’ai dans ce domaine, c’est que finalement les pannes sont aujourd’hui de mieux en mieux documentées et beaucoup de sites web permettent d’obtenir des diagnostics ou de les poser relativement facilement. Malheureusement, il y a pas mal de vendeurs d’huile de serpent qui profitent aussi de cela pour être en tête des réponses des moteurs de recherche avec dans l’idée beaucoup un service à vendre qu’un réel bénéfice pour le consommateurs/utilisateurs.

Dans la capacité à diagnostiquer, il faut aussi inclure, et ce n’est pas simple non plus, l’outillage nécessaire. Autant certains diagnostics sont finalement assez simple à réaliser (« est-ce que la pompe vidange ? ») autant d’autres sont nettement plus compliqués (« Y a-t-il continuité entre le composant X et Y ? »). Pareil, c’est relativement crétin, mais avoir une caisse à outil avec ce qu’il faut pour démonter de l’électroménager, de l’électronique, avoir un multimètre, un petit compresseur, etc… et bien pour le moment, ce n’est pas forcément donné à tout le monde.

C’est un effort d’équipements, qui est d’autant plus difficile à faire valoir, qu’il ne servira qu’en cas de panne (donc normalement relativement peu souvent). Je me suis personnellement servi de mon multimètre en tout et pour tout une demi-douzaine de fois depuis que je l’ai acheté. Alors, certes, c’est pas cher, mais c’est compliqué à justifier.

# La possibilité/capacité de réparer

Une fois de diagnostic posé (composant dessoudé, joint mort, pompe de vidange hors service, etc…), vient le moment de passer à la réparation. Là, encore une fois, on va perdre quelques personnes supplémentaires. Le jouet du gamin ne fait du bruit ? C’est potentiellement juste un câble dessoudé mais encore faut-il avoir un fer à souder pour le réparer.

Fort heureusement, le kit du petit bricoleur standard (marteau, tourne-vis, etc…) suffit généralement amplement. Je ne saurais que trop conseiller à tout le monde de s’équiper d’un petit fer à souder. Ça ne coûte pratiquement rien et vous en aurez toujours l’utiliser en réalité (ne serait que pour réparer un fil de lampe sans avoir à mettre un domino dégueux sur le fil en question).

En dehors de l’outillage, il y a évidemment le souci des pièces. De ce point de vue, on peut remercier (sans ironie) l’Europe qui a passé tout un tas de législation sur la réparabilité notamment de l’électro-ménager qui obligent les fabricants à garder des pièces disponibles. C’est un pas dans le bon sens, mais malheureusement c’est assez insuffisant : ça n’est pas valable pour l’électronique grand public (consoles, téléphones mobiles, etc… seule les télévisions sont dans cette obligation à ma connaissance) ; ça ne fixe pas un prix maximum raisonnable pour le consommateur qui souhaite réparer ou faire réparer (ce qui veut dire que le fabricant de lave-linges peut faire payer 30 fois le prix du lave-linge pour une vulgaire pièce sans rien risquer).

Ce n’est donc toujours pas parfait, mais on n’a plus vraiment d’excuses pour ne pas tenter au moins une réparation ou ne pas tenter de faire réparer. À mon sens, il manque une incitation à réparer en dehors des périodes de garantie également. Les extensions de garantie ne sont que des produits financiers (et vendu comme tel) et sont généralement prohibitifs en terme de prix. Sans compter le fait qu’aucun appareil un tant soit peu bien construit ne connaît de vraies pannes dans ses 5 premières années d’utilisation : l’usure sur les pièces vient en général bien plus tard.

Je ne sais pas quelle forme pourrait prendre cette incitation (peut-être une intervention de l’État d’une manière ou d’une autre).

Bref, concernant le fait de réparer ou maintenir en bonne condition son appareil, on progresse. Encore une fois, rien n’est parfait, rien n’est définitif, rien n’est évident, rien n’est gagné. Mais on avance progressivement dans le bon sens.

**Pour moi, c’est aussi à cet instant qu’entrent en jeu les équations économiques à prendre en compte.** La réparation ne devrait jamais coûter plus cher que l’appareil neuf. Malheureusement, on sait que ce n’est pas toujours le cas.

Et il y a aussi un autre facteur à prendre en compte : **l’appareil en panne connaît-il en ce moment une rupture technologique qui permettrait de faire des économies énergétiques conséquentes ou d’améliorer de manière conséquente l’efficacité ou les performances de l’appareil ?**

Mettons que ton frigo tombe en panne. C’est une panne relativement conséquente. Depuis 6 mois, de nouveaux types de frigo sont disponibles. **Ils sont 100 fois plus efficaces énergétiquement** (chiffre sorti de mon cul bien évidemment). **Dans ce cas, et dans ce cas seulement**, je pense qu’il vaut mieux changer l’appareil au complet. Certes, tu pourrais réparer ton frigo et le faire durer quelques années de plus. Mais pendant ce temps, il va consommer 100 fois plus que l’appareil neuf. Ça n’en vaut à mon sens plus la peine.

# Conclusage

Y’a encore du boulot ! Mais y’a de l’espoir aussi. Les informations concernant la réparation des appareils sont de plus en plus faciles à trouver, les diagnostics de plus en plus simple à établir, les bricoleurs du dimanche de plus en plus nombreux.

Mais il manque encore pas mal de choses. Il y a clairement des emplois de réparateurs à créer. Parce que tout le monde ne sait pas, parce que tout le monde ne peut pas. Mais il faut pour cela que ces réparateurs pratiquent des tarifs raisonnables. Ou alors il faut que le coût des appareils neufs augmentent considérablement (ce qui va peut-être finir par arriver par la force des choses).

Ça c’était le front de la réparation. Sur le front du recyclage, il me paraît évident qu’il va falloir mieux traiter les appareils dysfonctionnels dans le temps. Qu’un lave-linge soit déclaré économiquement irréparable, je le conçois parfaitement. Est-ce une raison pour jeter l’ensemble ? Clairement, non. Il y a probablement encore de bonnes pièces dedans, qu’il faudrait extraire pour être utilisé sur les autres appareils compatibles.

Encore faut-il disposer de cette information (quel appareil utilise quoi, quelle chance pour que la pièce compatible soit disponible, etc…). Je ne sais pas qui doit faire l’effort de ce point de vue. J’aurais tendance à dire les industriels : ils connaissent mieux les appareils qu’ils vendent, ils savent les quantités produites et donc toujours en circulation, ils ont la capacité de produire et stocker les pièces. Mais peut-être faudrait-il penser à un système plus localisé.

Bref, il y a encore du boulot, là aussi.

Et concernant le fait de jeter ? Et bien, comme je l’ai dit, en ce qui me concerne, c’est si, et seulement si, il y a une rupture technologique qui permet de vraiment faire des économies d’énergie ou des économies de CO₂ considérable derrière. Il y a quelques années, ma voiture à essence s’est faite emboutir. Jusqu’à présent, je l’avais toujours réparée même si le coût des réparations étaient importants. Elle a été déclarée économiquement irréparable (pour un montant un peu juste à mon goût, on pourrait en reparler). J’ai décidé d’acheter un véhicule électrique d’occasion. Je ne suis pas un chantre de la voiture électrique (ça va être indispensable pour les transports du futur, mais ce n’est clairement pas LA solution pour le moment), mais c’est une rupture technologique majeure qui permet d’économiser de l’énergie et du CO₂.

C’est pour moi l’illustration quasi-parfaite de ce que je disais : si ce n’est pas cassé, on ne change pas (ou alors on vend éventuellement, mais surtout on ne jète pas) ; si c’est cassé, on répare, le plus possible ; si c’est cassé et qu’il y a une technologie bien meilleure disponible (pas plus performante, pas plus confortable, meilleure au sens énergétique et pollution), il faut remplacer.
