+++
title = "Véhicules électriques et EVSE"
date = 2023-08-12
[taxonomies]
tags = [ "véhicule électrique", "evse", "électricité" ]
+++

![img](/2023/08/explain_meme.jpg)

<!-- more -->

Petit essai sur les véhicules électriques et les EVSE ou comment je me suis rendu compte que les constructeurs automobiles ne se mettent pas du tout à la place de leurs clients, loin s’en faut.

Pour les néophytes sur le sujet (ou les gens qui ont l’intention d’acheter un véhicule électrique ou les gens qui en ont acheté un mais qui « n’y connaissent rien »), je vais commencer par un petit récapitulatif des connaissances nécessaires pour la charge d’un véhicule électrique.

C’est aussi pour poser un peu de vocabulaire et quelques bases sur la façon dont c’est normé. Et c’est pas inintéressant de voir et de comprendre les choix qui sont faits dans ce cadre.

# De quoi qu’on parle

Pour charger une voiture électrique, il y a quelques prérequis :
* il faut un câble Type 2 côté véhicule ;
* il faut également un appareil spécial pour communiquer avec la voiture, un EVSE : **E**lectric **V**ehicle **S**upply **E**quipment. Contrairement à ce que l’on dit couramment, il ne s’agit pas d’un « chargeur » mais d’un interrupteur un poil intelligent, plus de détails après.

Ce dernier est relié au réseau électrique (on verra comment plus tard).

Je ne parlerai pas ici (ou très peu) de charge en courant continu. D’abord parce que chaque constructeur a décidé d’utiliser un vocabulaire hyper marketing pour en parler (*optimum charge*, *fast charging*, *super charging*, etc…) et ensuite parce qu’on l’utilise excessivement rarement. Ce n’est pas comme ça qu’on charge un véhicule électrique au quotidien et ce n’est pas comme ça qu’on devrait le charger de toutes manières sinon nous allons recréer le problème infrastructurel des stations service, à savoir recréer des monopoles locaux sur les carburants.

## Câbles Type 2

Je parlerai ici exclusivement de câble Type 2. C’est le câble qui ressemble à ça :

![img](/2023/08/t2t2.webp)

C’est le câble standard en Europe : à gauche sur l’image côté véhicule et à droite côté borne de rechargement AC (courant alternatif, autrement dit les bornes que l’on trouve en ville, dans les bureaux, etc…).

Le câblage interne est indiqué sur la prise de droite :
* `PP` est le câble de proximité, il permet de couper le jus si l’on enlève le câble, c’est une mesure de sécurité.
* `CP` est le câble de contrôle, il permet au véhicule électrique de communiquer avec la borne.
* `PE`, c’est la masse.
* `N`, `L{1,3}` représente le neutre et les (potentielles) phases.

Oui parce que les véhicules électriques en Europe doivent supporter la charge sur 3 phases dans le cas où ils seraient branchés sur une borne tri-phasée. La plupart des particuliers ont de l’électricité mono-phasée chez eux, il y a aura donc seulement `L1` qui sera utilisée, `L2` et `L3` ne seront pas branchées.

> Note : en Amérique du Nord, on utilises un câble [J1772](https://en.wikipedia.org/wiki/SAE_J1772) (dit aussi Type 1), qui est mono-phasé par défaut, donc ne contient que 3 prises plus les deux câbles de contrôle/sécurité, mais le principe est exactement le même.

> Note : le CCS, ou Combo DC, utilise la terre et les deux lignes de contrôle, mais comprend également deux énormes tiges en dessous de la prise pour charger directement la batterie en courant continu. Mais le principe reste grosso modo le même.

Nous avons là un premier souci concernant le câble : certains fabricants de câble et certains constructeurs automobiles ne livrent pas au client le câble le plus capacitif possible. En effet, un câble Type 2 peut avoir les caractéristiques suivantes :
* il peut être 16A ou 32A : les deux formats sont supportés. Pour avoir la charge maximale sur un véhicule électrique, il faut avoir un câble 32A.
* il peut être mono-phasé ou tri-phasé : il existe des câbles sans `L2` ou `L3`.

Évidemment la capacité de charge du véhicule dépend de l’ensemble des paramètres, au moins-disant : capacité supportée par le véhicule, capacité de l’EVSE/borne **et capacité du câble**. Et ça fait une grosse différence, comme tu peux le voir ci-dessous :

| Capacité de charge | 16A   | 32A   |
|--------------------|-------|-------|
| Mono               | 3,7kW | 7,4kW |
| Tri                | 11kW  | 22kW  |

> Lecture du tableau : un câble mono-phasé 16A ne pourra jamais excéder une charge de 3,7kW. Un câble tri-phasé 32A pourra supporter jusqu’à 22kW de charge.

Autrement dit, il vaut mieux avoir un câble 32A tri-phasé. Il sera certes plus rigide et forcément un peu moins long, mais au moins, il permettra de charger à la capacité maximale du véhicule ou de l’EVSE. **Qui peut le plus peut le moins**, il pourra toujours servir dans les autres situations.

J’ai vu pas mal de néo-propriétaires de véhicule électrique se poser la question de pourquoi leur voiture était très lente à charger alors qu’ils avaient pourtant une borne très capacitive. Et la réponse était presque systématiquement le câble.

> Note : si tu veux calculer le temps de charge d’un véhicule électrique, je te conseille [cet outil](https://www.automobile-propre.com/simulateur-temps-de-recharge-voiture-electrique/).

## EVSE

Côté EVSE, c’est bien plus simple : un EVSE est simplement un gros interrupteur (un peu) intelligent. Il ne fait aucune conversion sur le courant, il permet simplement de vérifier que le véhicule est dans les bonnes conditions et que le câble de proximité est branché.

Il est néanmoins obligatoire pour charger un véhicule électrique : on ne peut pas simplement connecter le courant sur une prise Type 2 en reliant les câbles, ça ne fontionnera pas.

## Prises électriques

Là, je parle bien de prise électrique domestique. Encore une fois, simplement que nous ayons tous le même vocabulaire.

Une prise Schuko (ou prise Type E et Type F, les deux étant compatibles entre elles) est une prise électrique standard en France. C’est les prises que tu as chez toi en gros, rien de plus rien de moins. Elles ne peuvent néanmoins par supporter plus de 16A et sont mono-phasées.

![img](/2023/08/Steckdose.jpg)

Si tu as bien suivi jusqu’à maintenant, ça veut dire que sur une prise domestique standard avec une EVSE portable (celui que ton constructeur te fournit généralement), tu peux charger à 3,7kW maximum.

Pour les prises électriques domestiques plus capacitives (tri-phasées 16A, mono-phasées 32A, tri-phasées 32A), il faut se diriger vers [les prises camping](https://fr.wikipedia.org/wiki/CEI_60309), de ce type :

![img](/2023/08/16A-plug.jpg)

# La charge d’un véhicule électrique au quotidien

Voilà, maintenant que le décor est posé, que faut-il pour charger un véhicule électrique au quotidien ? C’est en fait assez simple : généralement on charge à la maison, donc on a le fameux câble fourni par le constructeur qu’on branche sur une prise Schuko.

![img](/2023/08/cable-de-recharge-pour-prise-domestique.jpg)

Mais en fait, ce n’est pas vraiment un câble. C’est un **EVSE** avec une prise Schuko d’un côté et une prise Type 2 de l’autre, le tout attaché ensemble et indissociable.

Quand on commence à se servir de son véhicule un peu plus souvent, on peut éventuellement avoir besoin de charger *plus vite*. Ce câble supporte effectivement 16A mono-phasé, donc c’est 3,7kW max si les prises le permettent, autrement dit une charge relativement lente pour un véhicule électrique (mais largement supportable pour 80% des gens).

Quand on a besoin de plus, on peut installer un EVSE en dur chez soi. J’ai personnellement acheté et monté un [OpenEVSE](https://www.openevse.com/), version 100% Open Source et Open Hardware, qui me permet de charger mon véhicule électrique en 32A mono-phasé, autrement dit la plus grosse charge possible pour un particulier (hors tri-phasé, mais je considère que c’est plus une exception que la règle, en France néanmoins).

À noter qu’[OpenEVSE](https://www.openevse.com/) est monté par défaut sur un câble 6mm² (comme ton four) côté réseau, pas sur une prise électrique et qu’il est monté de l’autre avec une prise Type 2 **câblée en dur**.

# OK, je vois, mais du coup, de quoi on a besoin quand on part en vadrouille

Et c’est là que je voulais en venir et là que je trouve tous les systèmes actuels un peu stupides.

Autant pour faire des trajets autour de chez soi, on ne se pose généralement pas la question : on charge chez soi et voilà. Mais dès qu’on est en vadrouille un peu plus loin, il faut pouvoir se charger sur une infrastructure publique. Et donc là, il n’y a plusieurs possibilités :
* les charges DC (courant continu) que je mets un peu à part parce que les câbles sont toujours attachés directement à la borne pour des raisons de sécurité, donc pas de souci de ce côté ;
* pour se charger sur des bornes AC publiques, **il faut obligatoirement un câble Type 2** et de préférence tri-phasé 32A histoire de profiter de la charge la plus rapide possible (voire plus haut) ;
* si on n’a pas de borne publique disponible, **il faut obligatoirement son câble constructeur avec un EVSE dessus**, pour pouvoir se brancher sur n’importe quelle prise électrique.

Donc le propriétaire standard de véhicule électrique se retrouve souvent dans une situation débile où il faut trimballer un câble Schuko/EVSE/Type 2 et un câble Type 2/Type 2.

C’est **débilissime**.

En fait, je ne comprends vraiment pas pourquoi tout n’est pas en kit.

Ce serait tellement plus simple d’avoir :
* un câble Type 2/Type 2 (tri-phasé, 32A, voilà toussa, TMTC) ;
* un EVSE portable avec une capacité 32A (pas bien compliqué en fait, un OpenEVSE devrait pouvoir se glisser dans un petit boîtier dans problème) et qui embarquerait une prise Type 2 femelle ;
* un adaptateur Schuko, mais qu’on pourrait très bien remplacer par un adapteur camping ou pour d’autres prises finalement, ça n’a que peu d’importance.

Ça fait un seul câble Type 2 à se trimballer. Et un EVSE miniaturisé autant que possible avec des prises électriques interchangeables. Ça permettrait même à la plupart des possesseurs de véhicules électriques de se passer complètement d’EVSE à la maison : il suffirait de le remplacer par une prise camping pour profiter une charge maximale…

# Et le pire, c’est que certains y ont pensé mais pas jusqu’au bout

Si tu regardes la [boutique de Telsa](https://shop.tesla.com/fr_fr/product/connecteur-mobile), ils ont un connecteur mobile (donc un EVSE) avec un adaptateur permettant de se brancher sur autre chose qu’une prise Schuko.

Ils ont des [prises anglaises](https://shop.tesla.com/fr_fr/product/adaptateur-pour-le-royaume-uni), des [prises suisses](https://shop.tesla.com/fr_fr/product/adaptateur-suisse), des [prises italiennes](https://shop.tesla.com/fr_fr/product/adaptateur-italie) et même des [prises camping 32A](https://shop.tesla.com/fr_fr/product/adaptateur-bleu---16a_32a).

Mais côté véhicule, tout est toujours câblé en dur. Donc, le posseseur de ce *connecteur mobile* va quand même être obligé de se trimballer avec un câble Type 2 à côté pour se charger sur les infrastructures publiques.

Encore une fois, **débilissime**.

# Conclusage (enfin presque)

Voilà, je n’ai trouvé personne que ça choque. Personne à qui ça pose problème. Je suis là seul comme un con à me dire que c’est mal branlé et ça rend ouf de voir que personne n’a pris le temps de comprendre ou d’analyser ça pour en déduire que c’est pas comme ça qu’il faudrait faire et qu’il y a probablement un produit à sortir.

Donc voilà, je cherche. Je cherche l’EVSE miracle qui ferait tout ça. Ou au pire, l’adaptateur qui permettrait de transformer un OpenEVSE en ce que je cherche.

J’ai déjà personnellement posé une prise Type 2 femelle sur mon OpenEVSE pour éviter d’avoir encore un câble qui traîne attaché. Donc ce n’est pas compliqué à faire.

Par contre, côté réseau électrique, je ne vois pas du tout. Telsa utilise une sorte de connecteur propriétaire, je chercherais plutôt un connecteur standard, mais relativement compact. Je ne sais pas si ça existe.

Dès que je trouve, crois bien que je vais commencer à le construire cet EVSE parfait.

